#include "engine\golf2d\g2d_eng.h"

#ifdef ARSSC_USING_ENGINE_GOLF2D

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>

#include "core\core.h"

G2DEngine::G2DEngine()
{
    A_LOG("Constructing Golf 2D Engine...", "Engine");

    A_LOG("Construction Done", "Engine");
}

G2DEngine::~G2DEngine()
{
    A_LOG("Deconstructing Golf 2D Engine", "Engine");
}

void G2DEngine::Load()
{
    A_LOG("Initilizing Golf 2D Engine...", "Engine");

    Keyboard = Core->Input->GetKeyboardMonitorList();

    level = new G2DLevel();

    level->Load(A_STR("TESTING"));

    LoadOGL();
    
    A_LOG("Initilization Done", "Engine");
}

void G2DEngine::Unload()
{
    A_LOG("Shutting Down Golf 2D Engine...", "Engine");

    delete level;

    A_LOG("Shutdown Done", "Engine");
}

void G2DEngine::LoadOGL()
{
    A_LOG("Loading OpenGL Data...", "Engine");

    Keyboard = Core->Input->GetKeyboardMonitorList();

    fonttexture = new AOGLTexture;
    fonttexture->InitLoadTGA(A_STR("data\\fonts\\default.tga"));
    font = new AOGLFont(A_STR("data\\fonts\\default.fm"));

    A_LOG("OpenGL Data Loading Complete", "Engine");
}

void G2DEngine::UnloadOGL()
{
    A_LOG("Unloading OpenGL Data...", "Engine");

    delete fonttexture;
    delete font;

    A_LOG("OpenGL Data Unloading Complete", "Engine");
}

void G2DEngine::Update(DWORD count)
{
    if(Keyboard[VK_UP].Down)       { level->MoveUp(count*0.5f); }
    if(Keyboard[VK_DOWN].Down)     { level->MoveDn(count*0.5f); }
    if(Keyboard[VK_LEFT].Down)     { level->MoveLf(count*0.5f); }
    if(Keyboard[VK_RIGHT].Down)    { level->MoveRt(count*0.5f); }

    level->Update(count);

    framecount.Frame(count);
}

void G2DEngine::Draw()
{
    level->Draw();

    fonttexture->UseTexture();
    glLoadIdentity();
    glTranslatef(900.0f, 24.0f, 0.0f);
    font->Text(A_STR("FPS: ")+AString(framecount.GetFPS()));
    
}

#endif // ARSSC_USING_ENGINE_GOLF2D

